import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { Form, Row, Col, Select } from 'antd'

class SettingForm extends Component {
  static propTpyes = {
    dict: PropTypes.object,      // 字典项
  }

  state = {
    appMenus: []
  }

  UNSAFE_componentWillMount () {
    let appMenus = sessionStorage.getItem('appViewList')
    if (appMenus) {
      try {
        appMenus = JSON.parse(appMenus)
        appMenus = appMenus.filter(item => item.keys_type !== 'index')
      } catch (e) {
        appMenus = []
      }
    } else {
      appMenus = []
    }

    this.setState({appMenus})
  }

  handleConfirm = () => {
    const { appMenus } = this.state
    // 表单提交时检查输入值是否正确
    return new Promise((resolve, reject) => {
      this.props.form.validateFieldsAndScroll((err, values) => {
        if (!err) {
          let item = appMenus.filter(_menu => _menu.keys_id === values.menu)[0]
          resolve(item)
        } else {
          reject(err)
        }
      })
    })
  }

  render() {
    const { getFieldDecorator } = this.props.form
    const { appMenus } = this.state

    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      }
    }

    return (
      <Form {...formItemLayout}>
        <Row gutter={24}>
          <Col span={20}>
            <Form.Item label="菜单">
              {getFieldDecorator('menu', {
                initialValue: '',
                rules: [{
                  required: true,
                  message: '请选择菜单!'
                }]
              })(
                <Select>
                  {appMenus.map(option =>
                    <Select.Option key={option.keys_id} value={option.keys_id}>{option.remark}</Select.Option>
                  )}
                </Select>
              )}
            </Form.Item>
          </Col>
        </Row>
      </Form>
    )
  }
}

export default Form.create()(SettingForm)